/********** GENERADOR DEL ALGORITMO ALLINKN PARA EL ALGORITMO DE PERES DE DIMENSION N **************/

#include <stdio.h>
#include <string.h>

#define MAXCAR 256

/**
Este programa escribe el cdigo en C del algoritmo comprueba que, dado un grafo, todos sus vrtices estn 
contenidos en un Kn, siendo n la dimensin considerada para el problema.

Alberto Sols Encina. Copyright 2010. Histrico:
			13-12-2010: - Aadidos bucles genricos.
			15-12-2010: - Modificado el ndice de variables como contador numrico.
			27-12-2010: - Utilizacin de funciones de manipulacin del fichero propias de C.
			30-12-2010: - Tipo del main modificado a 'int' para devolver cdigo de error.
			30-12-2010: - Cdigo compilado correctamente.
			07-01-2011: - Incluido <stdio.h>

**/

/** main devuelve -1 en caso de error, devuelve 0 en cualquier otro caso. **/
	int main (int argc, int argv[]){
			//Varbiables del programa
			/** pasamos como argumento la dimensin con la que trabajar (dim)**/
			long dim=(long)atoi(argv[1]);
			char s [MAXCAR];
			FILE *f;
			int variable_indice=0; //Se usa en las variables.
			int contador_for=0;

		//Apertura de fichero
			if ((f=fopen("AllInKn.c","w")) == NULL){
				perror("Error al abrir el archivo f");
				return -1;}

		 /** El numero de indices que podemos usar corresponde a la cantidad representable por el tipo 'int' de C **/
		 
		sprintf(s,"/** AllInKn para dimensin %ld **/\n",dim);	
		fputs(s, f); //uso de formato de texto
		sprintf(s,"/** Alberto Solis Encina. Copyright 2011. MA1.**/\n");
		fputs(s, f);

		 sprintf(s,"/** Comprueba que todo vrtice est contenido en un Kn, donde n sera la dimensin del problema **/\n\n");
		 fputs(s, f);

		sprintf(s,"#include <stdio.h>\n\n");
		fputs(s,f);
		 
		 sprintf(s,"/** Resuelve el problema de todo vrtice en un Kn para dimensin %d **/ \n\n",dim);
		 fputs(s, f);

		 //-------------------------------------------------------------------------------
		 sprintf(s,"int allInKn (graph * g, int m, int n){ \n\n");
		 fputs(s, f);
		 
		 //****************** Declaraciones de variables**********************************
		 
		 sprintf(s,"int vertex;\n int isVertexInKn=0;\n");
		 fputs(s, f);

		 //Deben declararse por tanto el mismo nmero de variables como TAKEBIT se usen
		 for(variable_indice=0;variable_indice<dim;variable_indice++){
			sprintf(s,"int var%d;\n", variable_indice);
			fputs(s, f);
		 }
		
		 //Deben declararse tantos setwords como nmero de 'while' que aparecen y que almacenan los vecinos adyacentes
		 for(variable_indice=0;variable_indice<dim;variable_indice++){
			sprintf(s,"setword ady%d;\n",variable_indice);
			fputs(s, f);
		 }

		 //********************************************************************************
		 
		
		 //Raz del anidamiento de bucles
		 sprintf(s, "\nfor(var0=0;var0<n;var0++){\n ady0=g[var0];\n");
		 fputs(s, f);
		 
		 //Bucle 'for' para generar el conjunto de bucles anidados
		 /**
		 Se generar tantos bucles anidados como dim-1.
		 El primer bucle se genera con for para recorrer todos los vrtices, el resto son 'whiles' y se va profundizando en los adyacentes comnes.
		 Entonces deben escribirse dim-2 bucles 'while'.
		 **/


		for(contador_for=1;contador_for<dim-1;contador_for++){
			sprintf(s, "\twhile(ady%d){\n \t\tTAKEBIT(var%d,ady%d);\n \t\tady%d=ady%d & g[var%d];\n",contador_for-1, contador_for, contador_for-1, contador_for, contador_for-1, contador_for);
			fputs(s, f);
		}

		
		//Nucleo base del anidamiento. La variable ady ser la ltima declarada.
		sprintf(s, "\n\t\tif(ady%ld){ //Existe un adyacente comn\n\t\t isVertexInKn = 1;\n\t\tbreak;}\n", dim-2);
		fputs(s, f);
		
		//Cierre de los bucles abiertos (corchetes).
		/**
			Para cerrar los bucles se generan bloques de "} if(VertexInKn) break;" tantos como nmero de bucles while escritos -1, es decir dim-3.
			Esto es as debido a que el ltimo ya queda en el estrato del for y debe comprobar si puede seguise o no el recorrido
		**/

		for(contador_for=0;contador_for<dim-3;contador_for++){
			sprintf(s, "}\n if(isVertexInKn) break;\n");
			fputs(s, f);
		}

		sprintf(s, "}\n if(!isVertexInKn) return 0;\n else isVertexInKn=0;\n}\n return 1;\n }//Fin de la funcion\n");
		fputs(s, f);
		
		//En caso de que se finalice el bucle for sin problemas significar que todos lo vrtices cumplen la condicin
	
	fclose(f);

return 0;
}
